# coding: utf-8

"""
    Weft Events Api

    The Weft Event Ingestion API is a RESTful API that allows you to submit events for processing and storage. The API is secured using the Bearer Authentication scheme with JWT tokens. To obtain a JWT token, please contact Weft at team@goweft.com 

    The version of the OpenAPI document: 2.3.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr

class LoginRequest(BaseModel):
    """
    LoginRequest
    """
    refresh_token: StrictStr = Field(..., alias="refreshToken", description="The refresh token issued previously during the authentication process. It is required to obtain a new access token.")
    __properties = ["refreshToken"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> LoginRequest:
        """Create an instance of LoginRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> LoginRequest:
        """Create an instance of LoginRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return LoginRequest.parse_obj(obj)

        _obj = LoginRequest.parse_obj({
            "refresh_token": obj.get("refreshToken")
        })
        return _obj


